;-----------------------------------------------------------------------------------------------
; MMX and SSE2 Graphics Experiments by Jeff Cummings ( jeffwebgamer@hotmail.com )
; Inspired by Andre LaMothe and Michael Abrash and the following web site:
; http://www.ronybc.8k.com
;
; 2:22am  9/24/05  Blocks are now in array, so next step is block initialization routine!
;
;
;
;
;

.686p
.MMX
.XMM
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
include \masm32\include\user32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\user32.lib

.data
ClassName    db "apocalypse",0
AppName      db "Jeff's Breakout with Assembly Language - Rectangles built bit by bit (using two threads) :-)",0,0,0,0,0,0
maxx         dd 10               ; 123: values set on execution
maxy         dd 10               ; this thing is best for comparing
startx       dd 201
starty       dd 301
lenx         dd 6
leny         dd 5
velx         dd 3
vely         dd 2
yoffset      dd 40
ballyoffset  dd 0
fcount       dd 0
frcount      dd 0
found        dd 0
stop         dd 0
blockwidth   dd 0
blockheight  dd 1
blockcolumns dd 10
blockrows    dd 10
blocknumb    dd 0
blocktotal   dd 100 ; one more than actual # of blocks...
block_x      dd 128 dup (0)
block_y      dd 128 dup (0)
block_c      dd 128 dup (00000ffh)
bminf     BITMAPINFO <<40,0,0,1,32,0,0,0,0,0,0>>
fps       db 128 dup (0)
fmat2     db "FPS: [%u]  Ball Location: [x=%u, y=%u] Breakout in progress. (http://www.jeffpowerweb.bravehost.com)",0

.data?
hInstance HINSTANCE ?
hwnd      LPVOID ?
wnddc     HDC ?
hFThread  HANDLE ?
hHeap     HANDLE ?
idThread1 DWORD ?
idThread2 DWORD ?
bitmap1   LPVOID ?
msg       MSG <>
wc        WNDCLASSEX <>

.code

FireThread:
    invoke SetThreadPriority,idThread1,THREAD_PRIORITY_HIGHEST
    invoke GetDC,hwnd
    mov wnddc,eax
    invoke GetProcessHeap
    mov hHeap,eax
; GAME INITIALIZATION
; BITMAP
    invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,3200000
    mov bitmap1,eax
; SIZE OF BITMAP
    mov eax, 1024           ; eax = 1024
    mov ebx, 768
    imul ebx                ; eax = 1024 * 768
    lea eax, [eax*4]        ; eax = 1024 * 768 * 4
    push eax                ; save eax for later.
; INIT BLOCKS ARRAYS x,y,c
; BLOCK_X
    lea edi, block_x
    mov eax, 0
    mov edx, 0
; loop # of rows
    mov ecx, blockrows
xrows1:
    push ecx
; loop # of columns
    mov ecx, blockcolumns
xcols1:
    mov [edi+edx*4], eax
    add eax, blockwidth
; space in between blocks
    add eax, 25
    inc edx
    loop xcols1
    pop ecx
    mov eax, 0
    loop xrows1
; set (# of columns) x vars, to # (calculated in loop)
; BLOCK_Y
    lea edi, block_y
    mov eax, 0
    mov edx, 0
; loop # of rows
    mov ecx, blockrows
yrows1:
    push ecx
; loop # of columns
    mov ecx, blockcolumns
ycols1:
    mov [edi+edx*4], eax
    inc edx
    loop ycols1
    add eax, blockheight
; space in between blocks
    add eax, 10
    pop ecx
    loop yrows1
; BLOCK_C
    
;; LOOP BEGINNING

startblock:
; DRAW ALL BLOCKS ON SCREEN
    mov ecx, blocktotal
new2:
    push ecx
; DRAW BLOCK NEW SEGMENT
    lea esi, block_x
    mov ebx, [esi+ecx*4]          ; ebx = x    
    lea esi, block_y
    mov edx, [esi+ecx*4]          ; edx = y
    imul edx, maxx          ; edx = y * maxx
    shl edx, 2              ; edx = 4 * y * maxx
    shl ebx, 2              ; ebx = x * 4
    add edx, ebx            ; edx = (y*maxx*4)+(x*4)
    mov edi, bitmap1
    add edi, edx            ; edi points to (x,y) on bitmap
    lea esi, block_c
    mov eax, [esi+ecx*4]          ; eax = color
    mov ecx, blockheight
new1:
    push ecx
    mov ecx, blockwidth
    cld
    rep stosd
    add edi, yoffset
    pop ecx
    loop new1
    pop ecx
    loop new2

; DRAW BALL ON SCREEN
    mov edi, bitmap1        ; (re) set point to index into bitmap beginning
    mov eax, startx         ; set eax to startx = 100
    shl eax, 2              ; eax = eax * 4 (size of 32-bit color pixel)
    add edi, eax            ; add eax to bitmap offset. (x,0)
    mov eax, starty         ; eax = starting y position.
    imul maxx               ; multiply by maxx (length of horizontal line across screen)
    shl eax, 2              ; multiply by 4
    add edi, eax            ; point edi to bitmap offset (x,y) !!

    sub edi, ballyoffset
    mov edx, leny

; DRAW BALL (SMALL BLOCK THAT MOVES)
new:
    add edi, ballyoffset
    mov ecx, lenx
    mov eax, 0000FFFFh
    cld
    rep stosd
    dec edx
    cmp edx, 0
    je done
    jmp new
done:

; MOVE SMALL BLOCK AND BOUNCE OFF SCREEN BOUNDARIES
; add velx to startx
    mov eax, startx
    add eax, velx
    cmp eax, 1
    jg notxzero1
    neg velx
notxzero1:
    mov startx, eax
    add eax, lenx
    cmp eax, maxx
    jl notmaxx1
    neg velx
notmaxx1:
; add vely to starty
    mov eax, starty
    add eax, vely
    cmp eax, 1
    jg notyzero1
    neg vely
notyzero1:  
    mov starty, eax
    add eax, leny
    cmp eax, maxy
    jl notmaxy1
    neg vely
notmaxy1:          

;-----------------------------------------------------------------------------------------------

; CHECK BALL FOR BOUNCING OFF BLOCKS
; (startx, starty)
; CHECK (X)

    mov ecx, 0
    lea esi, block_x
    lea edi, block_y
startchecking:
    mov eax, [esi+ecx*4]          ; load block X
    mov ebx, startx
    add ebx, lenx
    sub eax, ebx
    cmp eax, velx
    jg nothitx
    neg eax
    cmp eax, velx
    jl hitx
    mov eax, [esi+ecx*4]          ; load block X
    add eax, blockwidth
    sub eax, startx
    cmp eax, velx
    jl nothitx
    neg eax
    cmp eax, velx
    jg hitx
    jmp nothitx
; ball hit at startx = b1x1
hitx:
    mov eax, [edi+ecx*4]        ; load block Y
    cmp eax, starty
    jg nothitx
    add eax, blockheight
    cmp eax, starty
    jl nothitx
    neg velx
nothitx:

; CHECK (Y)
    mov eax, [edi+ecx*4]        ; load block Y
    mov ebx, starty
    add ebx, leny
    sub eax, ebx
    cmp eax, vely
    jg nothity
    neg eax
    cmp eax, vely
    jl hity
    mov eax, [edi+ecx*4]        ; load block Y
    add eax, blockheight
    sub eax, starty
    cmp eax, vely
    jl nothity
    neg eax
    cmp eax, vely
    jg hity
    jmp nothity
; ball hit at starty = b1y1
hity:
    lea esi, block_x
    mov eax, [esi+ecx*4]        ; load block X
    cmp eax, startx
    jg nothity
    add eax, blockwidth
    cmp eax, startx
    jl nothity
    neg vely
nothity:
    inc ecx
    cmp ecx, blocktotal
    jle startchecking

;-----------------------------------------------------------------------------------------------

; DISPLAY SCREEN TO USER
    invoke SetDIBitsToDevice,wnddc,0,0,maxx,maxy,\
           0,0,0,maxy,bitmap1,ADDR bminf,DIB_RGB_COLORS

; CLEAR SCREEN FOR NEXT FRAME TO BE WRITTEN
    pop eax
    push eax
    invoke RtlZeroMemory,bitmap1,eax
;    invoke Sleep, 12
    
; DISPLAY STATS TO COMMAND WINDOW STATUS BAR OR TITLE BAR ATOP PAGE
    inc fcount                 ; count the frames
    invoke wsprintf, ADDR fps, ADDR fmat2,frcount,startx,starty
    invoke SetWindowText,hwnd,ADDR fps

   invoke Sleep, 12
    
    mov eax,stop                ; check for exit
    test eax,eax
    jz startblock


;; END


    invoke ReleaseDC,hwnd,wnddc 
    invoke HeapFree,hHeap,0,bitmap1
    mov idThread1,-1
    invoke ExitThread,2003
    hlt                        ; ...! i8085 memories
; -------------------------------------------------------------------------
.code

MoniThread:
    invoke Sleep,1000
    mov eax, fcount
    mov frcount, eax        ;; frcount is frames/second counter sent to firethread.
    xor eax,eax
    mov fcount,eax
    mov eax,stop
    test eax,eax
    jz MoniThread
    mov idThread2,-1
    invoke ExitThread,2003

; -------------------------------------------------------------------------
WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    .IF uMsg==WM_CLOSE
        mov stop,1                  ; stop running threads
        invoke Sleep,100            ; avoid FireThread drawing without window
        invoke DestroyWindow,hwnd
        invoke PostQuitMessage,0
    .ELSEIF uMsg==WM_SIZE
	xor edx, edx
	mov eax, lParam
	mov dx, ax
	shr eax, 16
	shr edx, 2
	shl edx, 2
	mov maxx, edx
	mov maxy, eax
	mov bminf.bmiHeader.biWidth, edx
	neg eax
	mov bminf.bmiHeader.biHeight, eax
; calculate blockwidth
      mov eax, blockwidth
      cmp eax, 0
      jg moveon
      mov eax, maxx
      mov edx, 0
      mov ecx, blockcolumns
      div ecx
; space in between blocks
      sub eax, 25
      mov blockwidth, eax
moveon:
; calculate blockheight
      mov eax, 200
      mov edx, 0
      mov ecx, blockrows
      div ecx
      mov blockheight, eax
; YOFFSET for blocks
      mov eax, blockwidth     ; eax = blockwidth * 4
      mov edx, maxx           ; edx = maxx * 4
      sub edx, eax            ; edx = (maxx*4 - blockwidth*4)
      shl edx, 2
      mov yoffset, edx        ; yoffset = (maxx*4 - blockwidth*4)
; BALLYOFFSET for ball(s)
      mov eax, lenx           ; eax = lenx (ball length)
      mov edx, maxx           ; edx = maxx (x screen width)
      sub edx, eax            ; edx = edx - eax
      shl edx, 2
      mov ballyoffset, edx    ; ballyoffset = edx
    .ELSEIF uMsg==WM_KEYDOWN
        mov stop,1                  ; stop running threads
        invoke Sleep,100            ; avoid FireThread drawing without window
        invoke DestroyWindow,hwnd
        invoke PostQuitMessage,0
    .ELSE
        invoke DefWindowProc,hWnd,uMsg,wParam,lParam        
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc ENDP
; -------------------------------------------------------------------------

start:
    invoke GetModuleHandle,NULL
    mov hInstance,eax
    mov wc.hInstance,eax
    mov wc.cbSize,SIZEOF WNDCLASSEX
    mov wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNCLIENT
    mov wc.lpfnWndProc,OFFSET WndProc
    mov wc.cbClsExtra,NULL
    mov wc.cbWndExtra,NULL
    mov wc.hbrBackground,COLOR_MENUTEXT
    mov wc.lpszMenuName,NULL
    mov wc.lpszClassName,OFFSET ClassName
    invoke LoadCursor,NULL,IDC_ARROW
    mov wc.hCursor,eax
    invoke LoadIcon,hInstance,500
    mov wc.hIcon,eax
    mov wc.hIconSm,eax
    invoke RegisterClassEx,ADDR wc
    invoke CreateWindowEx,WS_EX_OVERLAPPEDWINDOW,ADDR ClassName,ADDR AppName,\
                          WS_OVERLAPPEDWINDOW,0,0,720,500,NULL,NULL,\
                          hInstance,NULL
    mov hwnd,eax
    invoke ShowWindow,hwnd,SW_SHOWNORMAL
    invoke UpdateWindow,hwnd
    finit
    invoke CreateThread,0,4096,ADDR MoniThread,0,0,ADDR idThread1
    invoke CreateThread,0,4096,ADDR FireThread,0,0,ADDR idThread2
    mov hFThread,eax
    MsgLoop:
        invoke GetMessage,ADDR msg,0,0,0
        test eax,eax
        jz EndLoop
        invoke TranslateMessage,ADDR msg
        invoke DispatchMessage,ADDR msg
        jmp MsgLoop
    EndLoop:
    @@: mov eax,idThread1
        or  eax,idThread2
        not eax
        and eax,eax
        jnz @B
    invoke ExitProcess,eax

end start
